Package: org.apache.groovy.typecheckers

## [Groovy] Class CheckingVisitor

- org.apache.groovy.typecheckers.CheckingVisitor

-     @AutoFinal
      @CompileStatic
      class CheckingVisitor
      extends ClassCodeVisitorSupport

  Base visitor support for type-checker extensions that need lightweight constant propagation and access to the underlying variable represented by a VariableExpression.

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `protected Map<Expression, Expression>` | `localConstVars` | Tracks local variables whose values are known constant expressions during the current visit.

  - ### Constructor Summary

    Constructors
    Constructor and description
    `CheckingVisitor()`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `protected Expression` | `findConstExp(Expression exp, Class type)` Resolves a constant expression of the requested type from an expression, following tracked locals and field initializers when possible.
    `` | `protected Variable` | `findTargetVariable(VariableExpression ve)` Follows VariableExpression.accessedVariable links until the original variable or field is found.
    `` | `protected SourceUnit` | `getSourceUnit()` Returns no backing source unit because subclasses report errors through the enclosing type-checking extension rather than this visitor.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class ClassCodeVisitorSupport` | `addError, getSourceUnit, visitAnnotation, visitAnnotations, visitAnnotations, visitAssertStatement, visitBlockStatement, visitBreakStatement, visitCaseStatement, visitCatchStatement, visitClass, visitClassCodeContainer, visitClosureExpression, visitConstructor, visitConstructorOrMethod, visitContinueStatement, visitDeclarationExpression, visitDoWhileLoop, visitExpressionStatement, visitField, visitForLoop, visitIfElse, visitImports, visitMethod, visitObjectInitializerStatements, visitPackage, visitProperty, visitReturnStatement, visitStatement, visitStatementAnnotations, visitSwitch, visitSynchronizedStatement, visitThrowStatement, visitTryCatchFinally, visitWhileLoop, visitYieldStatement`
    `class CodeVisitorSupport` | `afterSwitchCaseStatementsVisited, afterSwitchCaseStatementsVisited, afterSwitchConditionExpressionVisited, afterSwitchConditionExpressionVisited, visitArgumentlistExpression, visitArrayExpression, visitAssertStatement, visitAttributeExpression, visitBinaryExpression, visitBitwiseNegationExpression, visitBlockStatement, visitBooleanExpression, visitBreakStatement, visitBytecodeExpression, visitCaseStatement, visitCastExpression, visitCatchStatement, visitClassExpression, visitClosureExpression, visitClosureListExpression, visitConstantExpression, visitConstructorCallExpression, visitContinueStatement, visitDeclarationExpression, visitDoWhileLoop, visitEmptyStatement, visitExpressionStatement, visitFieldExpression, visitForLoop, visitGStringExpression, visitIfElse, visitLambdaExpression, visitListExpression, visitMapEntryExpression, visitMapExpression, visitMethodCallExpression, visitMethodPointerExpression, visitMethodReferenceExpression, visitNotExpression, visitPostfixExpression, visitPrefixExpression, visitPropertyExpression, visitRangeExpression, visitReturnStatement, visitShortTernaryExpression, visitSpreadExpression, visitSpreadMapExpression, visitStaticMethodCallExpression, visitSwitch, visitSwitchExpression, visitSynchronizedStatement, visitTernaryExpression, visitThrowStatement, visitTryCatchFinally, visitTupleExpression, visitUnaryMinusExpression, visitUnaryPlusExpression, visitVariableExpression, visitWhileLoop, visitYieldStatement`

- - ### Field Detail

    - #### protected final Map<Expression, Expression> localConstVars

      Tracks local variables whose values are known constant expressions during the current visit.

  - ### Constructor Detail

    - #### CheckingVisitor()

  - ### Method Detail

    - #### protected Expression findConstExp(Expression exp, Class type)

      Resolves a constant expression of the requested type from an expression, following tracked locals and field initializers when possible.

      Parameters:
        `exp` - expression to inspect
        `type` - required runtime type for the constant value
      Returns:
        the matching constant expression, or `null` when none can be resolved

    - #### protected Variable findTargetVariable(VariableExpression ve)

      Follows VariableExpression.accessedVariable links until the original variable or field is found.

      Parameters:
        `ve` - variable expression to resolve
      Returns:
        the underlying target variable

    - #### @Override
      protected SourceUnit getSourceUnit()

      Returns no backing source unit because subclasses report errors through the enclosing type-checking extension rather than this visitor.